#include <AccelStepper.h>
#define HALFSTEP 8

// Motor pin definitions
#define motorPin1  2     // IN1 on the ULN2003 driver 1
#define motorPin2  3    // IN2 on the ULN2003 driver 1
#define motorPin3  4     // IN3 on the ULN2003 driver 1
#define motorPin4  5     // IN4 on the ULN2003 driver 1

#define motorPin5  6     // IN1 on the ULN2003 driver 2
#define motorPin6  7     // IN2 on the ULN2003 driver 2
#define motorPin7  8    // IN3 on the ULN2003 driver 2
#define motorPin8  9    // IN4 on the ULN2003 driver 2

#define motorPin9   10     // IN1 on the ULN2003 driver 3
#define motorPin10  11    // IN2 on the ULN2003 driver 3
#define motorPin11  12    // IN3 on the ULN2003 driver 3
#define motorPin12  13    // IN4 on the ULN2003 driver 3

#define motorPin13  A1     // IN1 on the ULN2003 driver 4
#define motorPin14  A2    // IN2 on the ULN2003 driver 4
#define motorPin15  A3    // IN3 on the ULN2003 driver 4
#define motorPin16  A4    // IN4 on the ULN2003 driver 4


// Initialize with pin sequence IN1-IN3-IN2-IN4 for using the AccelStepper with 28BYJ-48
AccelStepper stepper1(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);
AccelStepper stepper2(HALFSTEP, motorPin5, motorPin7, motorPin6, motorPin8);
AccelStepper stepper3(HALFSTEP, motorPin9, motorPin11, motorPin10, motorPin12);
AccelStepper stepper4(HALFSTEP, motorPin13, motorPin15, motorPin14, motorPin16);

void setup() {
  Serial.begin(9600);
 int mi = 0;
  
  // put your setup code here, to run once:
  stepper1.setMaxSpeed(10000.0);
  stepper1.setAcceleration(500.0);
  stepper1.setSpeed(1000);
  stepper1.moveTo(0);

  stepper2.setMaxSpeed(10000.0);
  stepper2.setAcceleration(500.0);
  stepper2.setSpeed(1000);
  stepper2.moveTo(0);

  stepper3.setMaxSpeed(10000.0);
  stepper3.setAcceleration(500.0);
  stepper3.setSpeed(1000);
  stepper3.moveTo(0);

  stepper4.setMaxSpeed(10000.0);
  stepper4.setAcceleration(500.0);
  stepper4.setSpeed(1000);
  stepper4.moveTo(0);
    
}//--(end setup )---





void loop() {
  int mi = 0;
  int h = 0;
  int he = 0;
  for ( int i=0 ; i<10000 ;i++){
    stepper1.moveTo(412*(i%10));
    while (stepper1.distanceToGo() != 0){
            stepper1.run();
          }
          stepper1.stop();
          if (i != 10) {
            delay(1000);}
          
          if (i%10 == 0 and i !=0) {
           int mi = mi + 1;
            stepper2.moveTo(412*(mi%6));
            
             while (stepper2.distanceToGo() != 0){
            stepper2.run();
          }
          stepper2.stop();
          
          if (mi%6 == 0) {
            h = h+1;
            stepper3.moveTo(412*(h%10));
             while (stepper3.distanceToGo() != 0){
            stepper3.run();
          }
          stepper3.stop();
          if (h%10 == 0) {
            int he = he +1;
            stepper4.moveTo(412*(he%3));
             while (stepper4.distanceToGo() != 0){
            stepper4.run();
          }
          stepper4.stop();
          }
          }
          }
  }
}
  
 /* for ( int i=0 ; i<3 ; i++) {
    for ( int j=0 ; j<10 ; j++) {
      for ( int k=0 ; k<6 ; k++) {
        for ( int l=0 ; l<10 ; l++) {
          while (stepper1.distanceToGo() != 0){
            stepper1.run();
          }
          stepper1.stop();
          if (l != 10) {
            delay(2000);}
          stepper1.moveTo(412*l);
          Serial.print(l);
          
        }
        while (stepper2.distanceToGo() != 0){
          stepper2.run();
        }
        stepper2.stop();
        if (k != 9) {
          delay(10000);}
          stepper2.moveTo(412*k);
          Serial.print(k);
        
      }
      while (stepper3.distanceToGo() != 0){
        stepper3.run();
      }
      stepper3.stop();
      if (j != 9) {
        //delay(60000);
        stepper3.moveTo(412*j);
      }
    }
    while (stepper4.distanceToGo() != 0){
      stepper4.run();
    }
    stepper4.stop();
    if (i != 9) {
      //delay(60000);
      stepper4.moveTo(412*i);
    }
  }
}



/*
  
 for ( int l=0 ; l<10 ; l++) {
  while (stepper1.distanceToGo() != 0){
    stepper1.run();
  }
  stepper1.stop();
  delay(60000)
 } 
  
  Serial.begin(9600);
int  value = stepper1.distanceToGo();
  Serial.print(value);
 if (stepper1.distanceToGo() == 0) {
    stepper1.stop();
  }
  stepper1.run();

/*


   /*
  if (stepper2.distanceToGo() == 0) {
    stepper2.stop();
  }
  stepper2.run();


  if (stepper1.distanceToGo() == 0) {
    stepper1.stop();
  }
  stepper1.run();

  
   if (stepper3.distanceToGo() == 0) {
    stepper3.stop();
  }
  stepper3.run(); 

  if (stepper4.distanceToGo() == 0) {
    stepper4.stop();
  }
  stepper4.run(); 
}*/


